import java.awt.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.*;

public class MDITest2 extends JFrame implements ActionListener {

	private final String NEWFILE = "newfile";
	private final String CLOSE = "close";
	private final String OPENFILE = "openfile";
	
	 private JDesktopPane desktopPane = new JDesktopPane();
	
	public MDITest2() {
		setGUI();
		setVisible(true);
	}
	
	private void setGUI() {
		setLocation(100,40);
		setSize(500,400);
		add(desktopPane, BorderLayout.CENTER);
		desktopPane.setBackground(Color.YELLOW);
		setMenues();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	private void addJMenuItem(JMenu main, String caption, String cmd, KeyStroke key) {

		JMenuItem mn =new JMenuItem(caption);
		main.add(mn);
		mn.addActionListener(this);
		mn.setActionCommand(cmd);
		if (key!=null) {
			mn.setAccelerator(key);
		}

	}
	
	private void setMenues() {
		JMenuBar menubar = new JMenuBar();
		JMenu mainFile = new JMenu("File");
		
		
		menubar.add(mainFile);
		JMenuItem mnnewFile =new JMenuItem("neue Datei");
		mainFile.add(mnnewFile);
		mnnewFile.addActionListener(this);
		mnnewFile.setActionCommand(NEWFILE);
		mnnewFile.setAccelerator(KeyStroke.getKeyStroke(
				    KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		
		addJMenuItem(mainFile, "Datei laden", OPENFILE,
				KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		
		
		mainFile.addSeparator();
		JMenuItem mnclose =new JMenuItem("Schlieen");
		mnclose.addActionListener(this);
		mnclose.setActionCommand(CLOSE);
		mainFile.add(mnclose);
		
		this.setJMenuBar(menubar);
		
	    for (int i = 0; i < menubar.getComponentCount(); i++) {
	        JMenu main = (JMenu) menubar.getComponent(i);
	        main.setFont(new Font("Arial", Font.BOLD, 26));
	        for (int j = 0; j < main.getItemCount(); j++) {
	          Component c = main.getItem(j);
	          if (c instanceof JMenuItem) {
	            JMenuItem mn = (JMenuItem) c;
	            mn.setFont(new Font("Arial", Font.BOLD, 26));
	          }
	        }
	      }		
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		System.out.println(cmd);
		switch (cmd) {
		case NEWFILE:
			newWindow();
			break;
		case OPENFILE:
			openfiles();
			break;
		case CLOSE:
			dispose();
			break;
			default:
				JOptionPane.showConfirmDialog(null,"Fehlerhafter case-Fall",
						  "actionperformed",
				          JOptionPane.DEFAULT_OPTION,
				          JOptionPane.ERROR_MESSAGE);
		}		
	}
	
	private void addFrame(String filename) {
		MyJInternalFrame frame = new MyJInternalFrame(filename);
		int pos = desktopPane.getAllFrames().length+1;
	    frame.setBounds(pos*50, pos*50, 300, 100);  // x, y, w, h		
		desktopPane.add(frame);
		desktopPane.moveToFront(frame);
	}	
	private void newWindow() {
		addFrame("");		
	}
	
	private void openfiles() {
		JFileChooser filechooser = new JFileChooser();
		filechooser.setMultiSelectionEnabled(true);
		filechooser.setCurrentDirectory(new File("d:\\progs\\eclipse\\MDITest2\\src"));
		if (filechooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION) {
			for (File file : filechooser.getSelectedFiles()) {
				addFrame(file.getPath());
			}
		}
	}
	
	public static void main(String[] args) {
		new MDITest2();

	}



}
