import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.ArrayList;

import javax.swing.*;


public class MainFrame extends JFrame implements ActionListener {
	
	private final String CLOSE = "close";
	private final String OPENFILE = "openfile";
	private final String TEST1 = "test1";
	private final String TEST2 = "test2";
	
	 private JDesktopPane desktopPane = new JDesktopPane();
	
	
	public MainFrame() {
		setGUI();
		setVisible(true);
	}	
	
	
	private void setGUI() {
		setLocation(100,40);
		setSize(500,400);
		add(desktopPane, BorderLayout.CENTER);
		desktopPane.setBackground(Color.YELLOW);
		setMenues();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	private void addJMenuItem(JMenu main, String caption, String cmd, KeyStroke key) {

		JMenuItem mn =new JMenuItem(caption);
		main.add(mn);
		mn.addActionListener(this);
		mn.setActionCommand(cmd);
		if (key!=null) {
			mn.setAccelerator(key);
		}

	}
	
	private void setMenues() {
		JMenuBar menubar = new JMenuBar();
		JMenu mainFile = new JMenu("File");		
		menubar.add(mainFile);
		
		addJMenuItem(mainFile, "Datei laden", OPENFILE,
				KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		
		
		mainFile.addSeparator();
		JMenuItem mnclose =new JMenuItem("Schlieen");
		mnclose.addActionListener(this);
		mnclose.setActionCommand(CLOSE);
		mainFile.add(mnclose);
		
		// ----------------- GRAPHICS
		
		JMenu mainGraphics = new JMenu("Graphics");		
		menubar.add(mainGraphics);
		
		addJMenuItem(mainGraphics, "Test1", TEST1, 
				KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.CTRL_MASK));
		addJMenuItem(mainGraphics, "Test2", TEST2, 
				KeyStroke.getKeyStroke(KeyEvent.VK_2, ActionEvent.CTRL_MASK));
		
		
		mainGraphics.addSeparator();
		
		
		
		this.setJMenuBar(menubar);
		
	    for (int i = 0; i < menubar.getComponentCount(); i++) {
	        JMenu main = (JMenu) menubar.getComponent(i);
	        main.setFont(new Font("Arial", Font.BOLD, 26));
	        for (int j = 0; j < main.getItemCount(); j++) {
	          Component c = main.getItem(j);
	          if (c instanceof JMenuItem) {
	            JMenuItem mn = (JMenuItem) c;
	            mn.setFont(new Font("Arial", Font.BOLD, 26));
	          }
	        }
	      }		
	}
		
	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		// System.out.println(cmd);
		switch (cmd) {
		case OPENFILE:
			// openfiles();
			break;
		case TEST1:
			test1();
			break;
		case TEST2:
			test2();
			break;
		case CLOSE:
			dispose();
			break;
			default:
				JOptionPane.showConfirmDialog(null,"Fehlerhafter case-Fall",
						  "actionperformed",
				          JOptionPane.DEFAULT_OPTION,
				          JOptionPane.ERROR_MESSAGE);
		}		
	}
	
	private void test1() {
		String filename = "bsp01.grf";
		MyJInternalFrame1 frame = new MyJInternalFrame1(filename);
		int pos = desktopPane.getAllFrames().length+1;
	    frame.setBounds(pos*50, pos*50, 300, 100);  // x, y, w, h		
		desktopPane.add(frame);
		desktopPane.moveToFront(frame);		
	}
	
	private void test2() {
		System.out.println("test2");
		ArrayList<GrfLine> liste = new ArrayList<GrfLine>();
		GrfLine line = new GrfLine();
		liste.add(line);
		 line = new GrfLine();
		liste.add(line);
		for (GrfLine grfobj : liste ) {
			System.out.println(grfobj);
		}
	}
	
	public static void main(String[] args) {
		new MainFrame();
	}

	

}
